
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class ConfigurationMenuListener implements ActionListener {

    private MyWorld world;
    private PhysicsLabPanel labmi;

    public ConfigurationMenuListener(MyWorld w, PhysicsLabPanel lab) {
        world = w;
        labmi = lab;
    }

    public void actionPerformed(ActionEvent e) {

        JMenuItem menuItem = (JMenuItem) (e.getSource());
        String text = menuItem.getText();


        if (text.equals("Bloque")) {
            world.addElement(new GBloque(10f, new Vector2D(200f, 200f), new Vector2D(), 10f));
        }
        if (text.equals("Bloque de Piso")) {
            world.addElement(new GPiso(new Vector2D(200f, 100f), 30f));
        }
        if (text.equals("Bloque y Pilar")) {
            GPilar spring = new GPilar(60f, 400f, new Vector2D(400f, 400f), new Vector2D(400f, 490f), world, labmi);
            world.addElement(spring);
            world.addElement(new GBloque(10f, new Vector2D(400f, 400f), new Vector2D(), 10f));

            AttachableElement element = world.findAttachableElement(400, 400);
            Vector2D u = spring.getAendPosition();

            if ((u.getX() == 400f) && (u.getY() == 400f)) {
                spring.attachAend(element);
            }

            labmi.repaint();
        }
        if (text.equals("Delete")) {
            world.setCursor();
        }
        if (text.equals("Piso")) {
            for (int i = 1; i < 31; i++) {
                world.addElement(new GPiso(new Vector2D(i * 60f, 650f), 60f));
            }
        }


    }
}
