import javax.swing.JPanel;
import java.awt.event.*;
import java.awt.event.MouseAdapter;
import java.awt.*;
import java.awt.Cursor;


public class MouseListener extends MouseAdapter {
   private MyWorld world;
   private PhysicsElement ele;  
	private Drawable currentElement;
   private JPanel panel;
   /** 
 * Constructor MouseListener.   copia sus atributos con los entregados
 * @param w Objeto MyWorld 
 * @param p Panel
 */  
   public MouseListener (MyWorld w, JPanel p){
      world = w;
      panel = p;
   } 
 /** 
 *Evento al mover el mouse 
 */  
   
   public void mouseMoved(MouseEvent e) {
      Drawable newElement = world.find(e.getX(), e.getY());
      if (newElement == currentElement) return;
      if (currentElement != null) {
         currentElement.setReleased();
         currentElement = null;
      }
      if (newElement != null) { 
         currentElement = newElement;
         currentElement.setSelected();
      }
      panel.repaint();
  
    }
 /** 
 *Evento al realizar un click con el mouse
 */  	 
	 public void mouseClicked(MouseEvent e)
    {
	      currentElement = world.find(e.getX(), e.getY());
		   ele = (PhysicsElement) currentElement;  
			
			if(panel.getCursor().getType()==Cursor.CROSSHAIR_CURSOR){
           if (currentElement != null && e.getClickCount() >= 1)
           world.removeElement(ele);
           world.resetCursor();
	      }
	 }

	 
	 
	  /** 
 *Evento al arrastrar con el click el mouse
 */  
  
   public void mouseDragged(MouseEvent e) {
      if (currentElement == null) return;
      currentElement.dragTo(e.getX(), e.getY());
      panel.repaint();
   }
   	  /** 
 *Evento al soltar el click con el mouse. En este evento se define si se une un elemento arrastrado con otro.
 */  
  
 	public void mouseReleased(MouseEvent e) {
      if (currentElement != null) 
         currentElement.setReleased();
      	   if ((!(currentElement instanceof GPilar))){
				    currentElement = null;
           return;
            }   
   
	   	 // we dragged an attachable element
          // we dragged a spring, so we look for and attachable element near by  
      AttachableElement element = world.findAttachableElement(e.getX(), e.getY());
      if (element == null) {
         currentElement = null;
         return;
      }
      // we dragged a spring and it is near an attachable element,
      // so we hook them to the right spring end.
     	  
	  if(currentElement instanceof GPilar){
	   		
      GPilar spring = (GPilar) currentElement;
		Vector2D u=spring.getAendPosition();
      if ((u.getX()==e.getX()) && (u.getY()==e.getY())) spring.attachAend(element);
		Vector2D z =spring.getBendPosition();
      if ((z.getX()==e.getX()) && (z.getY()==e.getY())) spring.attachBend(element);
		currentElement = null;
      panel.repaint();
	  }	
	
	
	}
	

	
}