
import java.awt.Graphics2D;
/**
 * Clase abstracta que heredaran objetos Fisicos los cuales deben cambiar sus estados al comenzar la simulación
 * @author Agustin G.
 */
public abstract class PhysicsElement {

    private final int myId;

    protected PhysicsElement(int id) {
        myId = id;
    }

    protected int getId() {
        return myId;
    }

    public void setInitialState(Vector2D g, float viscosity) {
    }

    public void computeNextState(double delta_t, Vector2D gravity, float viscosity) {
    }

    public void updateState() {
    }
}