import java.util.*;

public class Piso extends AttachableElement {
   private static int id=0;
   private Vector2D pos_t;     // current position at time t
   private Vector<Pilar> springs;  // Vector can grow, arrays cannot. 
  	  		
   private Piso(){   // nobody can create a block without state
     super(id++);
     
   }
   public Piso(Vector2D pos){
      super(id++);
      pos_t = pos;
      springs = new Vector<Pilar>();
		
   }
   public void attachPilar (Pilar spring) {
    springs.add(spring);
   }
   public void detachPilar (Pilar spring) {
     springs.remove(spring);
   }
  
 
   public Vector2D getPosition() {
      return pos_t;
   }
   public double getX() {
      return pos_t.getX();
   }
   public double getY() {
      return pos_t.getY();
   }
  public void setPosition(double x, double y){
      pos_t.set(x,y);
   }
  
}
 
